<?php
use WHMCS\Database\Capsule;

//Onload Create Table if not exists
if (!Capsule::schema()->hasTable("vdopanel_globalsetting")) {
  Capsule::schema()->create("vdopanel_globalsetting", function ($table) {
      $table->increments("id");
      $table->string("vdosetting");
      $table->dateTime('createdate')->default(Capsule::raw('CURRENT_TIMESTAMP'));
  });
  
  $insert = Capsule::table('vdopanel_globalsetting')->insert([
    'vdosetting' => 'off',
  ]);
}

function VdoPanel_productcreatecustomfields(array $vars)
{
    try {
        $cfieldsdetails = Capsule::table('tblcustomfields')
            ->where('fieldname', 'username')
            ->where('relid', $vars['pid'])
            ->get();
        
        $count = count($cfieldsdetails);
        if($count == 0){
            $productdetails = Capsule::table("tblproducts")
                    ->where('id',$vars['pid'])
                    ->select('servertype')
                    ->get();
            $servertype = $productdetails['0']->servertype;
            if($servertype == "vdopanel"){
                Capsule::table('tblcustomfields')->insert([
                    'type' => 'product',
                    'relid' => $vars['pid'],
                    'fieldname' => 'username',
                    'fieldtype' => 'text',
                    'regexpr' => '/^[a-z\d_]{4,20}$/i',
                    'showorder' => 'on',
                    'description' => 'Enter your preferred username. If you leave it blank, the system will automatically generate one for you. Note: Please avoid using special characters in the username.A username between 4 and 20 characters in length,',
                ]);
            }
        }
    } catch (Exception $error) {
        
    }
}


$settingdata = Capsule::table('vdopanel_globalsetting')
                          ->get();
$getglobalsetting = $settingdata['0']->vdosetting;
if($getglobalsetting === 'on'){
   add_hook('ProductEdit', 1, 'VdoPanel_productcreatecustomfields'); 
}

add_hook('ClientAreaHeadOutput', 1, function($vars) {
  $template = $vars['templatefile'];
  if($template == "configureproduct"){
       $code .='
                <script type="text/javascript">
                $(document).ready(function(){
                  $("label:contains(username)").html("Enter Your Preferred Username.");
                });
                </script>';
      return $code;
  }
});

add_hook('AdminAreaFooterOutput', 1, function($vars) {
   $filename = $vars["filename"];
   if($filename == "configgeneral"){
       $tabs = '<li><a class="tab-top" href="#vdoPanelSetting" role="tab" data-toggle="tab">VDO Panel</a></li>';
       
       $vdosetting = Capsule::table('vdopanel_globalsetting')
            ->get();
       
       $setting = $vdosetting['0']->vdosetting;
       
       if($setting === 'on'){
           $checked = "checked";
       }else{
           $checked = "";
       }
       
       $contentdetails = '
             
               <div class="tab-pane" id="vdoPanelSetting">
                   <div class="custom-container">
                      <div class="row">
                         <div class="col-md-12">
                            
                            <table class="form" width="100%" border="0" cellspacing="2" cellpadding="3">
                               <tbody>
                                  <tr>
                                    <td class="fieldlabel">VDO panel Show custom username</td>
                                      <td class="fieldarea">
                                        <label class="checkbox-inline">
                                          <input type="checkbox" name="vdocustomfields" class="vdocustomfields" id="vdocustomfields" value="on" '.$checked.'>
                                          Tick to show username custom field on client area
                                        </label>
                                      </td>
                                    </tr>
                                  <tr>
                                     <td class="fieldlabel" width="370"></td>
                                     <td class="fieldarea">
                                        <button type="button" class="mt-20 btn btn-success update-vdo-setting">Update Setting</button>
                                     </td>
                                  </tr>
                                  
                               </tbody>
                            </table>
                            
                            
                         </div> 
                      </div>
                   </div>
              </div>
               
            ';
            
        $minifydetails = vdopanel_hook_minify_html($contentdetails); // Minify for javascript output
       
        $code .="
                <script type='text/javascript'>
                $(document).ready(function(){
                  var appendtabs = '$tabs';
                  var appenddetails = '$minifydetails';
                  $('.nav.nav-tabs.admin-tabs').append(appendtabs);
                  $('.tab-content.admin-tabs').append(appenddetails);
                });
                </script>";
                
        $code .='
           <script>
              $(document).on("click",".update-vdo-setting",function(e){
                    var $thisclone = $(this);
                    $(this).html("Updating...");
                    $(this).prop( "disabled", true );
                    
                    if($("#vdocustomfields").prop("checked") == true){
                        var setting = "on";
                    }
                    else if($("#vdocustomfields").prop("checked") == false){
                        var setting = "off";
                    }
                    
                    $.ajax({
                       type: "POST",
                       url: "",
                       data: {"ActionOnHookVDO":"AjaxMethodForVDO","action":"updatesetting","setting": setting},
                      }).done(function(data) {
                          $($thisclone).prop( "disabled", false );
                          $($thisclone).html("Update Setting");
                      });
                });
           </script>
        ';       
        return $code;
   }
});



if(isset($_POST["ActionOnHookVDO"])){
  $ActionOnHookVDO= $_POST["ActionOnHookVDO"];
  if($ActionOnHookVDO == "AjaxMethodForVDO"){
      $action = $_POST["action"];//Get Action
      
      if($action == "updatesetting"){
          //Need to find product data have or not
           $settingdata = Capsule::table('vdopanel_globalsetting')
                          ->get();
            $postedsetting = $_POST["setting"];
            $countsettingdata = count($settingdata);
            if($countsettingdata > 0){
                $id = $settingdata['0']->id;
                //Need to update data
                $update = Capsule::table('vdopanel_globalsetting')
                 ->where('id', $id)
                 ->update(['vdosetting' => $postedsetting]);
                 if($update){
                     echo "success";
                     die;
                 }
            }else{
                //Need to insert data
                $insert = Capsule::table('vdopanel_globalsetting')->insert([
                    'vdosetting' => $postedsetting,
                ]);
                if($insert){
                     echo "success";
                     die;
                }
            }
      }
      
      
  }
}






add_hook('ShoppingCartValidateProductUpdate', 1, function($vars) {
    $customfields = $vars["customfield"];
    foreach($customfields as $key => $value){
        $customfielddetails = Capsule::table("tblcustomfields")
                    ->where('id',$key)
                    ->where('fieldname','username')
                    ->where('type','product')
                    ->select('relid')
                    ->get();
        $count = count($customfielddetails);
        if($count >= 1){
            $pid = $customfielddetails['0']->relid;
            $productdetails = Capsule::table("tblproducts")
                    ->where('id',$pid)
                    ->select('servertype','servergroup','configoption1')
                    ->get();
            $servertype = $productdetails['0']->servertype;
            $servergroup = $productdetails['0']->servergroup;
            if($servertype == "vdopanel"){
                
                if(!empty($value)){
                    $groupdetails = Capsule::table("tblservergroupsrel")
                    ->where('groupid',$servergroup)
                    ->first();
                    $serverid = $groupdetails->serverid;
                    $serverdetails = Capsule::table("tblservers")
                        ->where('id',$serverid)
                        ->first();
                    
                    $params['configoption1'] =  $productdetails['0']->configoption1;
                    $params['serverhttpprefix'] = 'https';
                    $params['serverhostname'] = $serverdetails->hostname;
                    $params['serveraccesshash'] = $serverdetails->accesshash;
                    
                    $returnvalue = json_decode(checkVdoPanelUsername($params,$value),true);
                    
                    //print_r($returnvalue["success"]);die;
                    
                    if($returnvalue["success"] == '1'){
                        echo "Username ($value) already exists";die;
                    }else{
                        //nothing to do
                    }
                    
                    
                }
            }
            
        }
        
    }
});


function checkVdoPanelUsername($params,$clientname){
    
            $mainusername = $clientname;
            $user_type = $params['configoption1'];
            
            if($user_type == 'Broadcaster'){
                $apipath = "/api/check-broadcaster";
            }elseif($user_type == 'Reseller'){
                $apipath = "/api/check-reseller";
            }elseif($user_type == 'Reseller Broadcaster'){
                $apipath = "/api/reseller/check-broadcaster";
            }
            
            $urlfname = $params['serverhttpprefix'] . "://" . $params['serverhostname']. $apipath;
           
           
           
           $token = $params['serveraccesshash'];
           $postParams['token'] = $params['serveraccesshash'];
           $postParams['name'] = $mainusername;
            
            $postString = "";
            foreach($postParams as $key=>$value) { $postString .= $key.'='.$value.'&'; }
            rtrim($postString, '&');
            

            

            $ch = curl_init();
            curl_setopt($ch,
                CURLOPT_HTTPHEADER, 
                array(
                     'Content-Type: application/x-www-form-urlencoded',
                     "token: $token"
                    )
            );
            curl_setopt($ch, CURLOPT_URL, $urlfname);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_HEADER, false);
            //curl_setopt($ch, CURLOPT_POST, count($postString));
            curl_setopt($ch, CURLOPT_POSTFIELDS, $postString);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

            $output = curl_exec($ch);
            return $output;
            
            
            //$returncode = curl_getinfo($process, CURLINFO_HTTP_CODE);
            if (curl_errno($ch)) {
                return 'Curl error: ' . curl_error($ch);
            }

            curl_close($ch);
            
            $json_response = json_decode($output, true);
            
            $status = $json_response["status"];
            
            if($status == 'error'){
                return $mainusername;
            }else{
                return 'error';
            }
    
}

function vdopanel_hook_minify_html($input) {
    if(trim($input) === "") return $input;
    // Remove extra white-space(s) between HTML attribute(s)
    $input = preg_replace_callback('#<([^\/\s<>!]+)(?:\s+([^<>]*?)\s*|\s*)(\/?)>#s', function($matches) {
        return '<' . $matches[1] . preg_replace('#([^\s=]+)(\=([\'"]?)(.*?)\3)?(\s+|$)#s', ' $1$2', $matches[2]) . $matches[3] . '>';
    }, str_replace("\r", "", $input));
    

    return preg_replace(
        array(
            // t = text
            // o = tag open
            // c = tag close
            // Keep important white-space(s) after self-closing HTML tag(s)
            '#<(img|input)(>| .*?>)#s',
            // Remove a line break and two or more white-space(s) between tag(s)
            '#(<!--.*?-->)|(>)(?:\n*|\s{2,})(<)|^\s*|\s*$#s',
            '#(<!--.*?-->)|(?<!\>)\s+(<\/.*?>)|(<[^\/]*?>)\s+(?!\<)#s', // t+c || o+t
            '#(<!--.*?-->)|(<[^\/]*?>)\s+(<[^\/]*?>)|(<\/.*?>)\s+(<\/.*?>)#s', // o+o || c+c
            '#(<!--.*?-->)|(<\/.*?>)\s+(\s)(?!\<)|(?<!\>)\s+(\s)(<[^\/]*?\/?>)|(<[^\/]*?\/?>)\s+(\s)(?!\<)#s', // c+t || t+o || o+t -- separated by long white-space(s)
            '#(<!--.*?-->)|(<[^\/]*?>)\s+(<\/.*?>)#s', // empty tag
            '#<(img|input)(>| .*?>)<\/\1>#s', // reset previous fix
            '#(&nbsp;)&nbsp;(?![<\s])#', // clean up ...
            '#(?<=\>)(&nbsp;)(?=\<)#', // --ibid
            // Remove HTML comment(s) except IE comment(s)
            '#\s*<!--(?!\[if\s).*?-->\s*|(?<!\>)\n+(?=\<[^!])#s'
        ),
        array(
            '<$1$2</$1>',
            '$1$2$3',
            '$1$2$3',
            '$1$2$3$4$5',
            '$1$2$3$4$5$6$7',
            '$1$2$3',
            '<$1$2',
            '$1 ',
            '$1',
            ""
        ),
    $input);
}









