<?php

if (!defined("WHMCS")) {
    die("This file cannot be accessed directly");
}

use WHMCS\Database\Capsule;
function vdopanel_MetaData() {
    return array(
        'DisplayName' => 'VDO Panel',
        'APIVersion' => '2.7',
        'ServiceSingleSignOnLabel' => 'Login to System',
        'AdminSingleSignOnLabel' => 'Login to Admin',
        'ListAccountsUniqueIdentifierDisplayName' => 'Username',
        'ListAccountsUniqueIdentifierField' => 'username',
        'ListAccountsProductField' => 'configoption1',
    );
}

function vdopanel_LoadBroadcasterTemplates($params) {
    $list['Viewers_limit'] = ' Limit';
    return $list;
}

function vdopanel_ConfigOptions() {

    $customjs = '
       <script>
          $(document).ready(function(){
                forinitialloadmodule();
          });
       </script>
    ';

    $configarray = array(
        "utype" => [
            "FriendlyName" => "Account Type",
            "Type" => "radio",
            "Onclick" => "test()",
            "Options" => 'Broadcaster,Reseller,Reseller Broadcaster',
            //"Description" => $customjs,
        ],
        "broadcaster_type" => [
            "FriendlyName" => "Broadcaster Type",
            "Type" => "dropdown",
            "Options" => [
                '1' => 'Live Streaming',
                '2' => 'Web TV',
                '3' => 'Hybrid (Live Streaming and Web TV)',
            ],
        ],
        "lang" => [
            "FriendlyName" => "Choose Language ",
            "Type" => "dropdown",
            "Options" => [
                'Arabic - العربية' => 'Arabic - العربية',
                'Czech - Čeština' => 'Czech - Čeština',
                'English - English' => 'English - English',
                'Español - Spanish' => 'Español - Spanish',
                'Français - French' => 'Français - French',
                'Hebrew - עִברִית' => 'Hebrew - עִברִית',
                'Italiano - Italian' => 'Italiano - Italian',
                'Persian - فارسی' => 'Persian - فارسی',
                'Polski - Polish' => 'Polski - Polish',
                'Pусский - Russian' => 'Pусский - Russian',
                'Română - Romanian' => 'Română - Romanian',
                'Türkçe - Turkish=>' => 'Türkçe - Turkish',
                'Ελληνικά - Greek' => 'Ελληνικά - Greek',
                '汉语 - Chinese' => '汉语 - Chinese',
            ],
        ],
        
        "viewers_limit" => [
            "FriendlyName" => "Viewers Limit (0 value for unlimited)",
            "Type" => "text",
            "Size" => "25",
        ],
        "tv_storage" => [
            "FriendlyName" => "Tv Station Storage in megabyte (0 value for unlimited)",
            "Type" => "text",
        ],
        "bitrate" => [
            "FriendlyName" => "Maximum Bitrate ",
            "Type" => "dropdown", # Dropdown Choice of Options
            "Options" => [
                '288' => ' Low bitrate, sub-SD resolution - 288 kbps ',
                '448' => ' Medium bitrate, SD resolution - 448 kbps ',
                '1152' => ' High bitrate, higher-than-SD resolution - 1152 kbps ',
                '2048' => '  Very High bitrate, HD 720p resolution - 2048 kbps ',
                '4096' => '  Very High bitrate, FHD 1080p resolution - 4096 kbps ',
                '90000' => '  Source bitrate, unlimited kbps ',
            ],
        ],
        "traffic" => [
            "FriendlyName" => "Traffic Per Month in megabyte (0 value for unlimited)",
            "Type" => "text",
        ],
        "youtube_streaming" => [
            "FriendlyName" => "Allow YouTube Streaming ",
            "Type" => "dropdown",
            "Options" => [
                '1' => 'Yes',
                '0' => 'No',
            ],
        ],
        "facebook_streaming" => [
            "FriendlyName" => "Allow Facebook Streaming ",
            "Type" => "dropdown",
            "Options" => [
                '1' => 'Yes',
                '0' => 'No',
            ],
        ],
        "telegram_streaming" => [
            "FriendlyName" => "Allow Telegram Streaming ",
            "Type" => "dropdown",
            "Options" => [
                '1' => 'Yes',
                '0' => 'No',
            ],
        ],
        "twitch_streaming" => [
            "FriendlyName" => "Allow Twitch Streaming ",
            "Type" => "dropdown",
            "Options" => [
                '1' => 'Yes',
                '0' => 'No',
            ],
        ],
        "periscope_streaming" => [
            "FriendlyName" => "Allow Periscope streaming ",
            "Type" => "dropdown",
            "Options" => [
                '1' => 'Yes',
                '0' => 'No',
            ],
        ],
        "dailymotion_streaming" => [
            "FriendlyName" => "Allow Dailymotion Streaming ",
            "Type" => "dropdown",
            "Options" => [
                '1' => 'Yes',
                '0' => 'No',
            ],
        ],
        "custom_streaming" => [
            "FriendlyName" => "Allow Custom Streaming ",
            "Type" => "dropdown",
            "Options" => [
                '1' => 'Yes',
                '0' => 'No',
            ],
        ],
        "r_account_limit" => [
            "FriendlyName" => "Account Creation Limit",
            "Type" => "text",
            "Size" => "30",
            "id" => "reseller_field",
        ],
        
        
        "multi_bitrate" => [
            "FriendlyName" => "Multi Bitrate",
            "Type" => "dropdown",
            "Options" => [
                'single' => 'Single',
                'multi' => 'Multi',
            ],
        ],
        
        "multi_bitrate_rese" => [
            "FriendlyName" => "Multi Bitrate Reseller",
            "Type" => "dropdown",
            "Options" => [
                'single' => 'Single',
                'multi' => 'Multi',
            ],
        ],
        
        "vdo_directory_rese" => [
            "FriendlyName" => "VDO Directory Reseller",
            "Type" => "dropdown",
            "Options" => [
                '1' => 'Yes',
                '0' => 'No',
            ],
        ],
        
        /*"billing_type" => [
            "FriendlyName" => "Billing Type ",
            "Type" => "dropdown",
            "Options" => [
                'monthly' => 'Monthly',
                'hourly' => 'Hourly',
            ],
        ],*/
    );

    return $configarray;
}

function vdopanel_CreateAccount(array $params) {


    $serviceid = $params['serviceid'];
    $user_type = $params['configoption1'];
    
    if($user_type == 'Broadcaster'){
        $api = "/api/add-broadcaster";
    }elseif($user_type == 'Reseller'){
        $api = "/api/add-reseller";
    }elseif($user_type == 'Reseller Broadcaster'){
        $api = "/api/reseller/add-broadcaster";
    }
    
    $url = $params['serverhttpprefix'] . "://" . $params['serverhostname'] . ":" . $params['serverport'] . $api;
    
    if(!empty($params["customfields"]["username"])){
        $mainusername = $params["customfields"]["username"];
    }elseif(!empty($params["username"])){
        $mainusername = $params['username'];
    }else{
        $mainusername = vdopanel_generateRandomUsername();
    }
    
    //echo $mainusername;die;


    $return = "";
    $token = $params['serveraccesshash'];

    // Record the call in WHMCS's module log.
    logModuleCall(
            'everestcast',
            __FUNCTION__,
            "Creating account, name: " . $mainusername,
            "account",
            "account"
    );

    logModuleCall(
            'everestcast',
            __FUNCTION__,
            $params,
            "start",
            "start"
    );

    try {
        $username = urlencode($mainusername);
        $password = urlencode($params['password']);
        $channel_name = $params['clientsdetails']['companyname'] != "" ? $params['clientsdetails']['companyname'] : $username;
        if (in_array('curl', get_loaded_extensions())) {
            $postParams['name'] = $mainusername;
            
                $urlwithtoken = $url.'?token='.$token;
            
                $curl = curl_init();
                
                curl_setopt_array($curl, array(
                  CURLOPT_URL => $urlwithtoken,
                  CURLOPT_RETURNTRANSFER => true,
                  CURLOPT_ENCODING => '',
                  CURLOPT_MAXREDIRS => 10,
                  CURLOPT_TIMEOUT => 0,
                  CURLOPT_FOLLOWLOCATION => true,
                  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                  CURLOPT_CUSTOMREQUEST => 'POST',
                  CURLOPT_POSTFIELDS => array(
                      'name' => $mainusername,
                      'email' => $params['clientsdetails']['email'],
                      'password' => $password,
                      'password_confirmation' => $password,
                      'company_name' => $channel_name,
                      'channel_name' => $channel_name,
                      'btype' => $params['configoption2'],
                      'account_limits' => urlencode($params['configoption14']),
                      'bitrate' => urlencode($params['configoption6']),
                      'Viewers_limit' => urlencode($params['configoption4']),
                      'youtube_streaming' => urlencode($params['configoption8']),
                      'facebook_streaming' => urlencode($params['configoption9']),
                      'twitch_streaming' => urlencode($params['configoption10']),
                      'periscope_streaming' => urlencode($params['configoption11']),
                      'dailymotion_streaming' => urlencode($params['configoption12']),
                      'custom_streaming' => urlencode($params['configoption13']),
                      'tv_storage' => urlencode($params['configoption5']),
                      'traffic' => urlencode($params['configoption7']),
                      'lang' => $params['configoption3'],
                      'telegram_streaming' => urlencode($params['configoption18'])
                      ),
                ));
                
                $response = curl_exec($curl);
                
                curl_close($curl);
                
               //print_r($response);die;
                

            $json_response = json_decode($response, true);
            
            //echo "<pre>"; print_r($json_response); die();

            logModuleCall(
                    'everestcast',
                    __FUNCTION__,
                    "Request response: " . $return . " (" . $returncode . ")",
                    "request",
                    "request"
            );

            
            
            if($json_response["success"] != true ){
                $rerror = print_r($json_response['errors'],true);
                return $rerror;
            }else{
                $update = Capsule::table('tblhosting')
                 ->where('id', $serviceid)
                 ->update(['username' => $mainusername]);
                return 'success';
            }
            
            
        } else {
            logModuleCall(
                    'everestcast',
                    __FUNCTION__,
                    $params,
                    "Curl is not installed on this server",
                    "Curl is not installed on this server"
            );

            return "Error : Curl is not installed on this server";
        }
    } catch (Exception $e) {
        // Record the error in WHMCS's module log.
        logModuleCall(
                'everestcast',
                __FUNCTION__,
                $params,
                $e->getMessage(),
                $e->getTraceAsString()
        );

        return "Exception : " . $e->getMessage();
    }

    return 'error';
}


function vdopanel_generateRandomUsername($length = 8) {
    // Define possible characters for the username
    $characters = 'abcdefghijklmnopqrstuvwxyz0123456789';
    $randomString = '';

    // Generate a random string of specified length
    for ($i = 0; $i < $length; $i++) {
        $randomString .= $characters[rand(0, strlen($characters) - 1)];
    }

    $prefix = 'v'; // You can change this prefix
    return $prefix . $randomString;
}



function vdopanel_ChangePackage(array $params) {
    
    $mainusername = $params['username'];
    

    $tokenid = $params['serveraccesshash'];
    $serverport = $params['serverport'] != "" ? ":" . $params['serverport'] : '';
    $user_type = $params['configoption1'];
    //$api = $user_type == 'Broadcaster' ? '/api/update-broadcaster/'.$mainusername  : '/api/update-reseller';
    
    if($user_type == 'Broadcaster'){
        $api = "/api/update-broadcaster";
    }elseif($user_type == 'Reseller'){
        $api = "/api/update-reseller";
    }elseif($user_type == 'Reseller Broadcaster'){
        $api = "/api/reseller/update-broadcaster";
    }
    
    $url = $params['serverhttpprefix'] . "://" . $params['serverhostname'] . $port . $api; 
    $return = "";
   
    // Record the call in WHMCS's module log.
    logModuleCall(
            'everestcast',
            __FUNCTION__,
            "Creating account, name: " . $mainusername,
            "account",
            "account"
    );


    logModuleCall(
            'everestcast',
            __FUNCTION__,
            $params,
            "start",
            "start"
    );

    try {
        switch ($params['configoption2']) {
            case 'Live Streaming':
                $btype = 1;
                break;
            case 'Web TV':
                $btype = 2;
                break;
            case 'Hybrid (Live Streaming + Web TV)':
                $btype = 3;
                break;
        }
        $username = urlencode($mainusername);
        $password = urlencode($params['password']);
        $channel_name = $params['clientsdetails']['companyname'] != "" ? $params['clientsdetails']['companyname'] : $username;
        if (in_array('curl', get_loaded_extensions())) {
            $postParams['reseller_name'] = $username;
            $postParams['name'] = $username;
            $postParams['email'] = urlencode($params['clientsdetails']['email']);
            $postParams['company_name'] = $channel_name; // for Reseller
            $postParams['channel_name'] = $channel_name; //for Broadcaster
            $postParams['password'] = $password;
            $postParams['password_confirmation'] = $password;

            $postParams['btype'] = $params['configoption2'];
            $postParams['lang'] = $params['configoption3'];
            $postParams['Viewers_limit'] = urlencode($params['configoption4']);
            $postParams['tv_storage'] = urlencode($params['configoption5']);
            $postParams['bitrate'] = urlencode($params['configoption6']);
            $postParams['traffic'] = urlencode($params['configoption7']);
            $postParams['youtube_streaming'] = urlencode($params['configoption8']);
            $postParams['facebook_streaming'] = urlencode($params['configoption9']);
            $postParams['telegram_streaming'] = urlencode($params['configoption18']);
            $postParams['twitch_streaming'] = urlencode($params['configoption10']);
            $postParams['periscope_streaming'] = urlencode($params['configoption11']);
            $postParams['dailymotion_streaming'] = urlencode($params['configoption12']);
            $postParams['custom_streaming'] = urlencode($params['configoption13']);
            //$postParams['billing_type'] = urlencode($params['configoption15']);
            
            $postParams['multi_bitrate'] = urlencode($params['configoption15']);
            $postParams['multi_bitrate_rese'] = urlencode($params['configoption16']);
            $postParams['vdo_directory_rese'] = urlencode($params['configoption18']);
            $postParams['wm_brandlogo'] = 0;

            //reseller parameter here
            $postParams['account_limits'] = urlencode($params['configoption14']);
           
            $postParams['token'] = $tokenid;
            $postParams['ftp'] = urlencode($params['clientsdetails']['customfields2']);

            /*$postString = "";
            foreach ($postParams as $key => $value) {
                $postString .= $key . '=' . $value . '&';
            }
            rtrim($postString, '&');*/
            
            //$postString = http_build_query($postParams);
            
            $postString = "";
            foreach($postParams as $key=>$value) { $postString .= $key.'='.$value.'&'; }
            rtrim($postString, '&');

            $ch = curl_init();
            
            //curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/x-www-form-urlencoded'));
            
            curl_setopt($ch,
                CURLOPT_HTTPHEADER,
                array(
                    'Content-Type: application/x-www-form-urlencoded',
                     "token: $tokenid",
                     "reseller_name: $mainusername"
                    )
            );
            
            $urlwithtoken = $url.'?token='.$tokenid;
            
            curl_setopt($ch, CURLOPT_URL, $urlwithtoken);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_HEADER, false);
            //curl_setopt($ch, CURLOPT_POST, count($postParams));
            curl_setopt($ch, CURLOPT_POSTFIELDS, $postString);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

            $output = curl_exec($ch);

            $returncode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
            if (curl_errno($ch)) {
                echo 'Curl error: ' . curl_error($ch);
            }

            curl_close($ch);

            $json_response = json_decode($output, true);

            logModuleCall(
                    'everestcast',
                    __FUNCTION__,
                    "Request response: " . $return . " (" . $returncode . ")",
                    "request",
                    "request"
            );

            $err = "";
            if (array_key_exists('errors', $json_response)) {

                if (is_array($json_response['errors'])) {
                    $err = "";
                    foreach ($json_response['errors'] as $key => $value) {
                        foreach ($value as $k => $v) {
                            $k = $key."_".$v.", ";
                            $err .= $k;
                        }
                    }
                }
                return $err;
            } elseif ($json_response['success'] == true) {


                return 'success';
            } else {

                logModuleCall(
                        'everestcast',
                        __FUNCTION__,
                        "success : " . $return,
                        $returncode,
                        $returncode
                );
                return 'success';
            }
            
        } else {
            logModuleCall(
                    'everestcast',
                    __FUNCTION__,
                    $params,
                    "Curl is not installed on this server",
                    "Curl is not installed on this server"
            );

            return "Error : Curl is not installed on this server";
        }
    } catch (Exception $e) {
        // Record the error in WHMCS's module log.
        logModuleCall(
                'everestcast',
                __FUNCTION__,
                $params,
                $e->getMessage(),
                $e->getTraceAsString()
        );

        return "Exception : " . $e->getMessage();
    }

    return 'error';
}

function vdopanel_SuspendAccount(array $params) {
    $user_type = $params['configoption1'];
    //$login = $user_type == 'Broadcaster' ? '/api/suspend-broadcaster/'  : '/api/suspend-reseller';
    if($user_type == 'Broadcaster'){
        $login = "/api/suspend-broadcaster";
        $name_para = 'broadcaster_name';
    }elseif($user_type == 'Reseller'){
        $login = "/api/suspend-reseller";
        $name_para = 'name';
    }elseif($user_type == 'Reseller Broadcaster'){
        $login = "/api/reseller/suspend-broadcaster";
        $name_para = 'broadcaster_name';
    }
    
    $url = $params['serverhttpprefix'] . "://" . $params['serverhostname'] . ":" . $params['serverport'] . $login;
    //$name_para = $user_type == 'Broadcaster' ? 'broadcaster_name':'name';
    $return = "";
    $token = $params['serveraccesshash'];
    try {
        // Record the call in WHMCS's module log.
        logModuleCall(
                'everestcast',
                __FUNCTION__,
                $params,
                "start",
                "start"
        );

        if (in_array('curl', get_loaded_extensions())) {
            $postParams = array(
                'token' => $token,
                "$name_para" => urlencode($params['username']),
            );
            $mainusername = $params['username'];
            //url-ify the data for the POST
            /*foreach ($postParams as $key => $value) {
                $postString .= $key . '=' . $value . '&';
            }
            rtrim($postString, '&');*/
            
            //$postString = http_build_query($postParams);
            $postString = "";
            foreach($postParams as $key=>$value) { $postString .= $key.'='.$value.'&'; }
            rtrim($postString, '&');

            $urlwithtoken = $url.'?token='.$token;

            $process = curl_init($urlwithtoken);
           //curl_setopt($process, CURLOPT_HTTPHEADER, array('Content-Type: application/x-www-form-urlencoded'));
           
            curl_setopt($process,
                CURLOPT_HTTPHEADER,
                array(
                    'Content-Type: application/x-www-form-urlencoded',
                     "token: $token",
                     "reseller_name: $mainusername"
                    )
            );
           
            curl_setopt($process, CURLOPT_HEADER, 0);
            curl_setopt($process, CURLOPT_USERPWD, $params['serverusername'] . ":" . $params['serverpassword']);
            curl_setopt($process, CURLOPT_TIMEOUT, 30);
            //curl_setopt($process, CURLOPT_POST, count($postParams));
            curl_setopt($process, CURLOPT_POSTFIELDS, $postString);
            curl_setopt($process, CURLOPT_SSL_VERIFYHOST, 0);
            curl_setopt($process, CURLOPT_SSL_VERIFYPEER, 0);
            curl_setopt($process, CURLOPT_RETURNTRANSFER, TRUE);
            curl_setopt($process, CURLOPT_FOLLOWLOCATION, TRUE);
            $return = curl_exec($process);
            //var_dump($return); die();
            $returncode = curl_getinfo($process, CURLINFO_HTTP_CODE);
            curl_close($process);

            $json_response = json_decode($return, true);
            
            //print_r($json_response);die;

            if($json_response["success"] != true ){
                $rerror = print_r($json_response['errors'],true);
                return $rerror;
            }else{
                return 'success';
            }
            
        } else {
            logModuleCall(
                    'everestcast',
                    __FUNCTION__,
                    $params,
                    "Curl is not installed on this server",
                    "Curl is not installed on this server"
            );

            return "Error : Curl is not installed on this server";
        }
    } catch (Exception $e) {
        // Record the error in WHMCS's module log.
        logModuleCall(
                'everestcast',
                __FUNCTION__,
                $params,
                $e->getMessage(),
                $e->getTraceAsString()
        );

        return "Exception : " . $e->getMessage();
    }

    return 'error';
}

/**
 * Un-suspend instance of a product/service.
 *
 * Called when an un-suspension is requested. This is invoked
 * automatically upon payment of an overdue invoice for a product, or
 * can be called manually by admin user.
 *
 * @param array $params common module parameters
 *
 * @see http://docs.whmcs.com/Provisioning_Module_SDK_Parameters
 *
 * @return string "success" or an error message
 */
function vdopanel_UnsuspendAccount(array $params) {
    $user_type = $params['configoption1'];
    
    //$login = $user_type == 'Broadcaster' ? '/api/unsuspend-broadcaster/'  : '/api/unsuspend-reseller';
    
    if($user_type == 'Broadcaster'){
        $login = "/api/unsuspend-broadcaster";
        $name_para = 'broadcaster_name';
    }elseif($user_type == 'Reseller'){
        $login = "/api/unsuspend-reseller";
        $name_para = 'name';
    }elseif($user_type == 'Reseller Broadcaster'){
        $login = "/api/reseller/unsuspend-broadcaster";
        $name_para = 'broadcaster_name';
    }
    
    
    $url = $params['serverhttpprefix'] . "://" . $params['serverhostname'] . ":" . $params['serverport'] . $login;
    //$name_para = $user_type == 'Broadcaster' ? 'broadcaster_name':'name';
    $return = "";
    $token = $params['serveraccesshash'];
    
    
    //echo "<pre>";print_r($params);echo "</pre>";die;
    
    try {
        logModuleCall(
                'everestcast',
                __FUNCTION__,
                $params,
                "start",
                "start"
        );

        if (in_array('curl', get_loaded_extensions())) {
            
            $mainusername = $params['username'];

            $postParams = array(
                'token' => $token,
                $name_para => urlencode($mainusername),
            );

            //url-ify the data for the POST
            /*foreach ($postParams as $key => $value) {
                $postString .= $key . '=' . $value . '&';
            }
            rtrim($postString, '&');*/
            
            //$postString = http_build_query($postParams);
            $postString = "";
            foreach($postParams as $key=>$value) { $postString .= $key.'='.$value.'&'; }
            rtrim($postString, '&');
            $urlwithtoken = $url.'?token='.$token;
            $process = curl_init($urlwithtoken);
            //curl_setopt($process, CURLOPT_HTTPHEADER, array('Content-Type: application/x-www-form-urlencoded'));
            
            curl_setopt($process,
                CURLOPT_HTTPHEADER,
                array(
                    'Content-Type: application/x-www-form-urlencoded',
                     "token: $token",
                     "reseller_name: $mainusername"
                    )
            );
            
            curl_setopt($process, CURLOPT_HEADER, 0);
            curl_setopt($process, CURLOPT_USERPWD, $params['serverusername'] . ":" . $params['serverpassword']);
            curl_setopt($process, CURLOPT_TIMEOUT, 30);
            //curl_setopt($process, CURLOPT_POST, count($postParams));
            curl_setopt($process, CURLOPT_POSTFIELDS, $postString);
            curl_setopt($process, CURLOPT_SSL_VERIFYHOST, 0);
            curl_setopt($process, CURLOPT_SSL_VERIFYPEER, 0);
            curl_setopt($process, CURLOPT_RETURNTRANSFER, TRUE);
            curl_setopt($process, CURLOPT_FOLLOWLOCATION, TRUE);
            $return = curl_exec($process);
            //var_dump($return); die();
            $returncode = curl_getinfo($process, CURLINFO_HTTP_CODE);
            curl_close($process);

            $json_response = json_decode($return,true);
            
            if($json_response["success"] != true ){
                $rerror = print_r($json_response['errors'],true);
                return $rerror;
            }else{
                return 'success';
            }
            
            
        } else {
            logModuleCall(
                    'everestcast',
                    __FUNCTION__,
                    $params,
                    "Curl is not installed on this server",
                    "Curl is not installed on this server"
            );

            return "Error : Curl is not installed on this server";
        }
    } catch (Exception $e) {
        // Record the error in WHMCS's module log.
        logModuleCall(
                'everestcast',
                __FUNCTION__,
                $params,
                $e->getMessage(),
                $e->getTraceAsString()
        );

        return "Exception : " . $e->getMessage();
    }

    return 'error';
}

/**
 * Terminate instance of a product/service.
 *
 * Called when a termination is requested. This can be invoked automatically for
 * overdue products if enabled, or requested manually by an admin user.
 *
 * @param array $params common module parameters
 *
 * @see http://docs.whmcs.com/Provisioning_Module_SDK_Parameters
 *
 * @return string "success" or an error message
 */
function vdopanel_TerminateAccount(array $params) {
    $user_type = $params['configoption1'];
    //$login = $user_type == 'Broadcaster' ? '/api/delete-broadcaster/'  : '/api/delete-reseller';
    
    if($user_type == 'Broadcaster'){
        $login = "/api/delete-broadcaster";
        $name_para = 'broadcaster_name';
    }elseif($user_type == 'Reseller'){
        $login = "/api/delete-reseller";
        $name_para = 'name';
    }elseif($user_type == 'Reseller Broadcaster'){
        $login = "/api/reseller/delete-broadcaster";
        $name_para = 'broadcaster_name';
    }
    
    
    $url = $params['serverhttpprefix'] . "://" . $params['serverhostname'] . ":" . $params['serverport'] . $login;
    //$name_para = $user_type == 'Broadcaster' ? 'broadcaster_name':'name';
    $return = "";
    $token = $params['serveraccesshash'];
    try {

        // Record the call in WHMCS's module log.
        logModuleCall(
                'everestcast',
                __FUNCTION__,
                $params,
                "start",
                "start"
        );

        if (in_array('curl', get_loaded_extensions())) {
            
            $mainusername = $params['username'];

            $postParams = array(
                'token' =>$token,
                "$name_para" => urlencode($mainusername),
            );
            
            //url-ify the data for the POST
            /*foreach ($postParams as $key => $value) {
                $postString .= $key . '=' . $value . '&';
            }
            rtrim($postString, '&');*/
            
            //$postString = http_build_query($postParams);
            
            $postString = "";
            foreach($postParams as $key=>$value) { $postString .= $key.'='.$value.'&'; }
            rtrim($postString, '&');
            
            $urlwithtoken = $url.'?token='.$token;
            $process = curl_init($urlwithtoken);
            //curl_setopt($process, CURLOPT_HTTPHEADER, array('Content-Type: application/x-www-form-urlencoded'));
            
            curl_setopt($process,
                CURLOPT_HTTPHEADER,
                array(
                    'Content-Type: application/x-www-form-urlencoded',
                     "token: $token",
                     "reseller_name: $mainusername"
                    )
            );
            
            curl_setopt($process, CURLOPT_HEADER, 0);
            curl_setopt($process, CURLOPT_USERPWD, $params['serverusername'] . ":" . $params['serverpassword']);
            curl_setopt($process, CURLOPT_TIMEOUT, 30);
            //curl_setopt($process, CURLOPT_POST, count($postParams));
            curl_setopt($process, CURLOPT_POSTFIELDS, $postString);
            curl_setopt($process, CURLOPT_SSL_VERIFYHOST, 0);
            curl_setopt($process, CURLOPT_SSL_VERIFYPEER, 0);
            curl_setopt($process, CURLOPT_RETURNTRANSFER, TRUE);
            curl_setopt($process, CURLOPT_FOLLOWLOCATION, TRUE);
            $return = curl_exec($process);
            $returncode = curl_getinfo($process, CURLINFO_HTTP_CODE);
            curl_close($process);

            $json_response = json_decode($return,true);
            
            if($json_response["success"] != true ){
                $rerror = print_r($json_response['errors'],true);
                return $rerror;
            }else{
                return 'success';
            }
            
            
        } else {
            logModuleCall(
                    'everestcast',
                    __FUNCTION__,
                    $params,
                    "Curl is not installed on this server",
                    "Curl is not installed on this server"
            );

            return "Error : Curl is not installed on this server";
        }
    } catch (Exception $e) {
        // Record the error in WHMCS's module log.
        logModuleCall(
                'everestcast',
                __FUNCTION__,
                $params,
                $e->getMessage(),
                $e->getTraceAsString()
        );

        return "Exception : " . $e->getMessage();
    }

    return 'error';
}

function vdopanel_AdminSingleSignOn(array $params) {
    global $op;
    $op = "AdminSingleSignOn";
    $login = "/api/loginasadmin";
    $url = $params['serverhttpprefix'] . "://" . $params['serverhostname'] . $login;

    try {

        logModuleCall(
                'everestcast',
                __FUNCTION__,
                $params,
                "start",
                "start"
        );

        if (in_array('curl', get_loaded_extensions())) {

            $token = $params['serveraccesshash'];
            // curl to the ( remote ) login page ( with authentication of admin )
            $postParams = array(
                'username' => urlencode($params['serverusername']),
                'password' => urlencode($params['serverpassword']),
                'token' => $token,
                'ip' => urlencode($params['serverip']),
            );

            // print_r($postParams);
            // print_r($url);die;
            
            

            //url-ify the data for the POST
            $postString = "";
            foreach ($postParams as $key => $value) {
                $postString .= $key . '=' . $value . '&';
            }
            rtrim($postString, '&');

            session_start();
            $process = curl_init($url);
            curl_setopt($process, CURLOPT_HTTPHEADER, array('Content-Type: application/x-www-form-urlencoded', 'BEARER:' . $token));
            curl_setopt($process, CURLOPT_HEADER, 0);
            curl_setopt($process, CURLOPT_USERPWD, $params['serverusername'] . ":" . $params['serverpassword']);
            curl_setopt($process, CURLOPT_TIMEOUT, 30);
            //curl_setopt($process, CURLOPT_POST, count($postParams));
            curl_setopt($process, CURLOPT_POSTFIELDS, $postString);
            curl_setopt($process, CURLOPT_SSL_VERIFYHOST, 0);
            curl_setopt($process, CURLOPT_SSL_VERIFYPEER, 0);
            curl_setopt($process, CURLOPT_RETURNTRANSFER, TRUE);
            curl_setopt($process, CURLOPT_FOLLOWLOCATION, TRUE);
            $response = curl_exec($process);
            //print_r($response);die;
            $returncode = curl_getinfo($process, CURLINFO_HTTP_CODE);
            curl_close($process);
            $json_response = json_decode($response);

            if (!$json_response || $returncode != 200) {
                return array(
                    'success' => false,
                    'errorMsg' => $return
                );
            } else {

                if ($json_response->success == false) {
                    logModuleCall(
                            'everestcast',
                            __FUNCTION__,
                            "error : " . $json_response->errors,
                            $returncode,
                            $returncode
                    );

                    return array(
                        'success' => false,
                        'error' => "Error : " . $json_response->errors,
                    );
                } else {
                    $api_token = $json_response->api_token;
                    $url = $params['serverhttpprefix'] . "://" . $params['serverhostname'] . "/admin-login-by-token/" . $api_token;
                    logModuleCall(
                            'everestcast',
                            __FUNCTION__,
                            "success : " . $response . " URL: " . $url,
                            $returncode,
                            $returncode
                    );
                    return array(
                        'success' => true,
                        'redirectTo' => $url,
                    );
                }
            }
        } else {
            logModuleCall(
                    'everestcast',
                    __FUNCTION__,
                    $params,
                    "Curl is not installed on this server",
                    "Curl is not installed on this server"
            );

            return array(
                'success' => false,
                'errorMsg' => "Curl is not installed on this server"
            );
        }
    } catch (Exception $e) {
        // Record the error in WHMCS's module log.
        logModuleCall(
                'everestcast',
                __FUNCTION__,
                $url,
                $e->getMessage(),
                $e->getTraceAsString()
        );

        return array(
            'success' => false,
            'errorMsg' => $e->getMessage(),
        );
    }
}

function vdopanel_ServiceSingleSignOn(array $params) {
    
    $mainusername = $params['username'];
    
    /*$table = "tblhosting";
    $where = array("username" => $mainusername);
    $result = select_query($table, 'tokenid', $where);
    $data = mysql_fetch_array($result);*/
   
    //print_r($data);die;
    
    $servertoken = $params['serveraccesshash'];
   
    $user_type = $params['configoption1'];
    //$login = $user_type == 'Broadcaster' ?"/broadcaster-login-by-token/" . $data['tokenid'] : "/reseller/reseller-login-by-token/" . $data['tokenid'];
    //$login = $user_type == 'Broadcaster' ?"/api/": "/reseller/reseller-login-by-token/" . $data['tokenid'];
    //$login = $user_type == 'Broadcaster' ?"/api/broadcaster-login-code?/" . $servertoken : "/reseller/reseller-login-by-token/" . $data['tokenid'];
    
    //$login = $user_type == 'Broadcaster' ?"/api/broadcaster-login-code?/" . $servertoken : "/api/reseller-login-code?/" . $servertoken;
    
    
    if($user_type == 'Broadcaster'){
        $login = "/api/broadcaster-login-code?/" . $servertoken;
    }elseif($user_type == 'Reseller'){
        $login = "/api/reseller-login-code?/" . $servertoken;
    }elseif($user_type == 'Reseller Broadcaster'){
       $login = "/api/reseller/broadcaster-login-code?/" . $servertoken;
       //$login = "/api/broadcaster-login-code?/" . $servertoken;
    }
    
    
    $url = $params['serverhttpprefix'] . "://" . $params['serverhostname'] . ":" . $params['serverport'] . $login; 
    
    
    
    $token = $data['tokenid'];
    
    try {

        logModuleCall('everestcast', __FUNCTION__, $params, "start", "start");

        if (in_array('curl', get_loaded_extensions())) {
            

            session_start();
            $process = curl_init($url);
            
            //curl_setopt($process, CURLOPT_HTTPHEADER, array('Content-Type: application/x-www-form-urlencoded'));

            
            curl_setopt($process,
                CURLOPT_HTTPHEADER,
                array(
                    'Content-Type: application/x-www-form-urlencoded',
                     "token: $servertoken",
                    )
            );
            
            // curl to the ( remote ) login page ( with authentication of admin )
            $postParams = array(
                'broadcaster_name' => $mainusername,
                'token' => $servertoken,
            );

            //url-ify the data for the POST
            $postString = "";
            foreach ($postParams as $key => $value) {
                $postString .= $key . '=' . $value . '&';
            }
            rtrim($postString, '&');
            
            curl_setopt($process, CURLOPT_HEADER, 0);
            curl_setopt($process, CURLOPT_USERPWD, $params['serverusername'] . ":" . $params['serverpassword']);
            curl_setopt($process, CURLOPT_TIMEOUT, 30);
            //curl_setopt($process, CURLOPT_POST, count($postParams));
            curl_setopt($process, CURLOPT_POSTFIELDS, $postString);
            curl_setopt($process, CURLOPT_SSL_VERIFYHOST, 0);
            curl_setopt($process, CURLOPT_SSL_VERIFYPEER, 0);
            curl_setopt($process, CURLOPT_RETURNTRANSFER, TRUE);
            curl_setopt($process, CURLOPT_FOLLOWLOCATION, TRUE);
            $response = curl_exec($process);
            $response;
            echo curl_error($process);
            $returncode = curl_getinfo($process, CURLINFO_HTTP_CODE);
            curl_close($process);
            
            $json_response = json_decode($response);
            $newtoken = $json_response->data->token;
            
            
            
            //$newlogin = $user_type == 'Broadcaster' ?"/broadcaster-login-by-token/" . $newtoken : "/reseller/reseller-login-by-token/" . $newtoken;
            
            if($user_type == 'Broadcaster'){
                $newlogin = "/broadcaster-login-by-token/" . $newtoken;
            }elseif($user_type == 'Reseller'){
                $newlogin = "/reseller/reseller-login-by-token/" . $newtoken;
            }elseif($user_type == 'Reseller Broadcaster'){
               $newlogin = "/broadcaster-login-by-token/" . $newtoken;
            }
            
            
            $newurl = $params['serverhttpprefix'] . "://" . $params['serverhostname'] . ":" . $params['serverport'] . $newlogin; 
    
    
            
            
            //return $json_response->data->token;
            
            if ($returncode != 200) {
                logModuleCall(
                        'everestcast',
                        __FUNCTION__,
                        "error : " . $response,
                        $returncode,
                        $returncode
                );

                return false;
            } else {

                if ($json_response->errors) {
                    logModuleCall(
                            'everestcast',
                            __FUNCTION__,
                            "error : " . $json_response->errors,
                            $returncode,
                            $returncode
                    );

                    return array(
                        'success' => false,
                        'error' => "Error : " . $json_response->errors,
                    );
                } else {

                    logModuleCall(
                            'everestcast',
                            __FUNCTION__,
                            "success : " . $response,
                            $returncode,
                            $returncode
                    );

                    return [
                        'success' => true,
                        'redirectTo' => $newurl
                    ];
                }
            }
        } else {
            logModuleCall(
                    'everestcast',
                    __FUNCTION__,
                    $params,
                    "Curl is not installed on this server",
                    "Curl is not installed on this server"
            );

            return [
                'success' => false,
                'errorMsg' => "Curl is not installed on this server"
            ];
        }
    } catch (Exception $e) {
        // Record the error in WHMCS's module log.
        logModuleCall(
                'everestcast',
                __FUNCTION__,
                $url,
                $e->getMessage(),
                $e->getTraceAsString()
        );

        return array(
            'success' => false,
            'errorMsg' => $e->getMessage(),
        );
    }
}

function vdopanel_ClientArea(array $params) {
  
    //echo "<pre>";print_r($params);die;
    // Determine the requested action and set service call parameters based on
    // the action.
    $requestedAction = isset($_REQUEST['customAction']) ? $_REQUEST['customAction'] : '';

    $templateFile = 'templates/server-login.tpl';

    $sso = vdopanel_ServiceSingleSignOn($params);


    //print_r($sso);die;
    
    $user_type = $params['configoption1'];
    //$login = $user_type == 'Broadcaster' ?"/broadcaster/" : "/reseller/";
    
    if($user_type == 'Broadcaster'){
        $login = "/broadcaster/";
    }elseif($user_type == 'Reseller'){
        $login = "/reseller/";
    }elseif($user_type == 'Reseller Broadcaster'){
       $login = "/broadcaster/";
    }
    

    return array(
            'tabOverviewReplacementTemplate' => $templateFile,
            'templateVariables' => array(
            'hostname' => $params['serverhostname'],
            'port' => $params['serverport'],
            'subloginurl' => $login,
            'serverusername' => $params['serverusername'],
            'serverpassword' => $params['serverpassword'],
            'user' => $params['clientsdetails']['email'],
            'mainusername' => $params['username'],
            'password' => $params['password'],
            'ssourl' => $sso['redirectTo']
        ),
    );
}


function vdopanel_ListAccounts(array $params) {

            //echo "<pre>";print_r($params);echo "</pre>";die;


            $accounts = [];
            
            //$serviceid = $params['serviceid'];
            $user_type = 'Broadcaster';
            //echo $user_type;die;
            
            //$billing_type = $params['configoption15'];
            
        
            //$api = $user_type == 'Broadcaster' ? "/api/add-broadcaster" : "/api/add-reseller";
            
            // if($user_type == 'Broadcaster'){
            //     $api = "/api/broadcasters";
            // }elseif($user_type == 'Reseller'){
            //     $api = "/api/reseller/broadcasters";
            // }elseif($user_type == 'Reseller Broadcaster'){
            //     $api = "/api/reseller/broadcasters";
            // }
            
            $api = "/api/broadcasters";
            
            $url = $params['serverhttpprefix'] . "://" . $params['serverhostname'] . ":" . $params['serverport'] . $api;

            $ch = curl_init();
            $token = $params['serveraccesshash'];

            $urlwithtoken = $url.'?token='.$token;

            $postData = array(
                   'token' => $token
                );
            $ch = curl_init();
            curl_setopt($ch,
                CURLOPT_HTTPHEADER,
                array(
                    'Content-Type: application/x-www-form-urlencoded',
                     "token: $token",
                    )
            );
            curl_setopt($ch, CURLOPT_URL, $urlwithtoken);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_HEADER, false);
            
            //curl_setopt($ch, CURLOPT_POST, 1);
            // Set the POST data
            //curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);

            $output = curl_exec($ch);

            $returncode = curl_getinfo($ch, CURLINFO_HTTP_CODE);

            if (curl_errno($ch)) {
                return 'Curl error: ' . curl_error($ch);
            }


            curl_close($ch);

            $json_response = json_decode($output, true);
            $allaccounts = $json_response["data"];

            //echo "<pre>";print_r($allaccounts);echo "</pre>";die;

            $accountlists = $allaccounts['0'];

            foreach($accountlists as $allaccount){
                //$join_date = Capsule::parse($allaccount->created_at);
                //print_r($allaccount);die;
                $accounts[] = [
                        'email' => $allaccount['email'],
                        'username' => $allaccount['name'],
                        'password' => $allaccount['ftp'],
                        'uniqueIdentifier' => $allaccount['name'],
                        'configoption1' => $user_type,
                        'primaryip' => '1.2.3.4',
                        'created' => date('Y-m-d H:i:s'),
                        'status' => 'Active',
                    ];
                //echo "<pre>";print_r($accounts);echo "</pre>";die;
            }

            //echo "<pre>";print_r($accounts);echo "</pre>";die;
            $getstatus = $json_response["success"];
           // echo "<pre>";print_r($json_response);echo "</pre>";die;
            
            if($getstatus == "1"){
                return [
                    'success'  => true, // Boolean value
                    'accounts' => $accounts,
                ];
            }else{
                return [
                    'success'  => false, // Boolean value
                ];
            }
}